/****************************************************************************
*
*                       MegaGraph Graphics Library
*
*               Copyright (C) 1991-1997 SciTech Software, Inc.
*                            All rights reserved.
*
*  ======================================================================
*       This library is free software; you can use it and/or
*       modify it under the terms of the SciTech MGL Software License.
*
*       This library is distributed in the hope that it will be useful,
*       but WITHOUT ANY WARRANTY; without even the implied warranty of
*       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*       SciTech MGL Software License for more details.
*  ======================================================================
*
* Filename:     $Workfile:   hello.pas  $
* Version:      $Revision:   1.3  $
*
* Language:     ANSI C
* Environment:  MSDOS/Win32 full screen
*
* Description:  Simple hello program showing how to get up and running
*               using the MGL. Supports both fullscreen DOS and Windows
*               as target platforms with the same source code.
*
* $Date:   01 Oct 1997 05:51:10  $ $Author:   KendallB  $
*
****************************************************************************/

uses MGLFx, MGLTypes;

/*------------------------------ Implementation ---------------------------*/

procedure _hello;
var
    dc: PMGLDC;
    xres, yres, i: int;
    driver: int := grDETECT;
    mode: int := grDETECT;
    evt: event_t;
begin
  /* Start the MGL with only the VGA 16 color driver active */
  MGL_registerDriver(MGL_VGA8NAME,VGA8_driver);
  if not MGL_init(@driver,@mode, '') then
    MGL_fatalError(MGL_errorMsg(MGL_result));
  dc := MGL_createDisplayDC(1);
  if dc = NIL then
    MGL_fatalError(MGL_errorMsg(MGL_result));
  MGL_makeCurrentDC(dc);

    /* Draw a simple pattern of lines on the display */
    xres := MGL_maxx+1;
    yres := MGL_maxy+1;
  i := 0;
  while i < xres do
  begin
        MGL_setColorCI(i mod 15);
        MGL_lineCoord(xres div 2,yres div 2,i,0);
        MGL_setColorCI((i+1) mod 15);
        MGL_lineCoord(xres div 2,yres div 2,i,yres);
        i +:= 5;
  end;
  i := 0;
  while i < yres do
  begin
        MGL_setColorCI((i+2) mod 15);
        MGL_lineCoord(xres div 2,yres div 2,0,i);
        MGL_setColorCI((i+3) mod 15);
        MGL_lineCoord(xres div 2,yres div 2,xres,i);
        i +:= 5;
  end;
  MGL_setColorCI(MGL_WHITE);
  MGL_lineCoord(0,0,xres-1,0);
  MGL_lineCoord(0,0,0,yres-1);
  MGL_lineCoord(xres-1,0,xres-1,yres-1);
  MGL_lineCoord(0,yres-1,xres-1,yres-1);

  /* Wait for a keypress or mouse click */
  EVT_halt(@evt, EVT_KEYDOWN);

  MGL_exit;
end;

begin
  MGL_setAppInstance(hInstance);
  _hello;
end.